package org.apcocoa.eclipse.editor2;

import org.apcocoa.eclipse.ApCoCoALanguageToolkit;
import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.apcocoa.eclipse.editors.IApCoCoAPartitions;
import org.eclipse.dltk.core.IDLTKLanguageToolkit;
import org.eclipse.dltk.internal.ui.editor.ScriptEditor;
import org.eclipse.dltk.ui.text.ScriptTextTools;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.IDocumentExtension3;
import org.eclipse.ui.IEditorInput;

public class ApCoCoAEditor2 extends ScriptEditor {

	public static final String EDITOR_ID = "org.apcocoa.eclipse.editors.ApCoCoADLTKEditor";

	public static final String EDITOR_CONTEXT = "#ApCoCoAEditorContext";

	protected void initializeEditor() {
		super.initializeEditor();
		setEditorContextMenuId(EDITOR_CONTEXT);
	}

	@Override
	public String getEditorId() {
		return EDITOR_ID;
	}

	protected IPreferenceStore getScriptPreferenceStore() {
		return ApCoCoAPlugin.getDefault().getPreferenceStore();
	}

	@Override
	public IDLTKLanguageToolkit getLanguageToolkit() {
		return ApCoCoALanguageToolkit.getDefault();
	}

	public ScriptTextTools getTextTools() {
		return ApCoCoAPlugin.getDefault().getTextTools();
	}

	protected void connectPartitioningToElement(IEditorInput input,
			IDocument document) {
		if (document instanceof IDocumentExtension3) {
			IDocumentExtension3 extension = (IDocumentExtension3) document;
			if (extension
					.getDocumentPartitioner(IApCoCoAPartitions.APCOCOA_PARTITIONING) == null) {
				ApCoCoATextTools tools = ApCoCoAPlugin.getDefault()
						.getTextTools();
				tools.setupDocumentPartitioner(document,
						IApCoCoAPartitions.APCOCOA_PARTITIONING);
			}
		}
	}
}
