package org.apcocoa.eclipse.editor2;

import org.apcocoa.eclipse.editors.ApCoCoAPartitionScanner;
import org.apcocoa.eclipse.editors.IApCoCoAPartitions;
import org.eclipse.dltk.ui.text.ScriptSourceViewerConfiguration;
import org.eclipse.dltk.ui.text.ScriptTextTools;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.jface.text.rules.IPartitionTokenScanner;
import org.eclipse.ui.texteditor.ITextEditor;

public class ApCoCoATextTools extends ScriptTextTools {

	private final static String[] LEGAL_CONTENT_TYPES = new String[] {
		IApCoCoAPartitions.APCOCOA_STRING, IApCoCoAPartitions.APCOCOA_COMMENT
	};
	
	private IPartitionTokenScanner fPartitionScanner;
	
	public ApCoCoATextTools(boolean autoDisposeOnDisplayDispose) {
		super(IApCoCoAPartitions.APCOCOA_PARTITIONING, LEGAL_CONTENT_TYPES,
				autoDisposeOnDisplayDispose);
		fPartitionScanner = new ApCoCoAPartitionScanner();
	}
	
	@Override
	public ScriptSourceViewerConfiguration createSourceViewerConfiguraton(
			IPreferenceStore preferenceStore, ITextEditor editor,
			String partitioning) {
		return new ApCoCoASourceViewerConfiguration(getColorManager(), 
				preferenceStore, editor, partitioning);
	}
	
	public IPartitionTokenScanner getPartitionScanner() {
		return fPartitionScanner;
	}
}
