package org.apcocoa.eclipse.internal.ui;

import org.apcocoa.eclipse.ApCoCoALanguageToolkit;
import org.apcocoa.eclipse.ApCoCoAPlugin;
import org.apcocoa.eclipse.internal.interpreter.ui.ApCoCoAInterpreterPreferencePage;
import org.eclipse.dltk.core.IDLTKLanguageToolkit;
import org.eclipse.dltk.core.IModelElement;
import org.eclipse.dltk.ui.AbstractDLTKUILanguageToolkit;
import org.eclipse.dltk.ui.ScriptElementLabels;
import org.eclipse.jface.preference.IPreferenceStore;

public class ApCoCoAUILanguageToolkit extends AbstractDLTKUILanguageToolkit {

	
	private static class ApCoCoAScriptElemantLabels extends ScriptElementLabels {
		public void getElementLabel(IModelElement element, long flags,
				StringBuffer buf) {
			StringBuffer buffer = new StringBuffer(60);
			super.getElementLabel(element, flags, buffer);
			String s = buffer.toString();
			if (s != null && !s.startsWith(element.getElementName())) {
				if (s.indexOf('$') != -1) {
					s = s.replaceAll("\\$", ".");
				}
			}
			buf.append(s);
		}

		protected char getTypeDelimiter() {
			return '$';
		}
	};

	public ScriptElementLabels getScriptElementLabels() {
		return new ApCoCoAScriptElemantLabels();
	}
	
	// @Override
	public IDLTKLanguageToolkit getCoreToolkit() {
		return ApCoCoALanguageToolkit.getDefault();
	}

	// @Override
	public IPreferenceStore getPreferenceStore() {
		return ApCoCoAPlugin.getDefault().getPreferenceStore();
	}
	
	public String getInterpreterPreferencePage() {
		return ApCoCoAInterpreterPreferencePage.PAGE_ID;
	}

}
